package My;

my $pkg="My";

use Exporter ();
@ISA=qw(Exporter);
@EXPORT=qw(set_env get_env cookie encode_entities decode_entities encode_uri decode_uri printE printA printT trl);

use strict;
use POSIX qw(geteuid);
use Class::Date qw(date);
use DBI;

#- DEFINICE GLOBALNIHO HASHE a jeho zakladnio nastaveni
my %my_env;
set_env("org", $pkg->org);
set_env("datum", $pkg->date_now);

#- fce vraci prefi v pravech pro prislusny web
sub web {
   my $web;
   $ENV{DOCUMENT_ROOT}=~/\/home(\/web-[^\/]+)\//;
   $web=$1;
   if(!defined($web)) {
      $ENV{PWD}=~/\/home(\/web-[^\/]+)\//;
      $web=$1;
      if(!defined($web)) {
         $ENV{_}=~/\/home(\/web-[^\/]+)\//;
         $web=$1;
         if(!defined($web)) {
            die "Nebylo mozne urcit web!";
         }
      }
   }
   return $web;
}

#- fce vraci url adresu webu
sub weburl {
   my $weburl;
   if($pkg->web eq "/web-intra") {
      $weburl="https://intra.chlup.net";
   }
   elsif($pkg->web eq "/web-mycompany") {
      $weburl="https://mycompany.chlup.net:563";
   }
   elsif($pkg->web eq "/web-mycompanydev") {
      $weburl="https://mycompanydev.chlup.net:564";
   }
   elsif($pkg->web eq "/web-mis") {
      $weburl="https://mis.chlup.net:873";
   }
   return $weburl;
}

#- fce vraci domenu dle webu
sub domain {
   my $domain;
   if($pkg->web eq "/web-intra") {
      $domain="chlup.net";
   }
   elsif($pkg->web eq "/web-mycompany") {
      $domain="chlup.net";
   }
   elsif($pkg->web eq "/web-mycompanydev") {
      $domain="chlup.net";
   }
   elsif($pkg->web eq "/web-mis") {
      $domain="meopta.com";
   }
   return $domain;
}

#- zaznam hodnoty do globalniho hashe
sub set_env {
   my ($key,$val)=@_;
   if($key eq "org" and $val!~/^\d$/) { # pokud je snaha nastavit org na neco jineho nez cislo bude to prevalcovano 0
      $val="0";
   }
   elsif($key eq "datum" and !$pkg->check_datum($val)) { # pokud je snaha datum nastavit na neco neplatneho, bude to prevalcovano aktualmim datem
      $val=$pkg->date_now;
   }
   $my_env{$key}=$val;
}

#- cteni hodnoty z globalniho hashe
sub get_env {
   my ($key)=@_;
   return $my_env{$key};
}

#- vraci absolutni cestu k webovemu koreni
sub www_path {
   return '/home/web-mycompany/www';
}

#- funkce zjistuje uzivatele a heslo k SQL - bezpecna funkce pro suid scripty bezici s pravy tvurce scriptu
sub sql_user_password {
   local $/="\n"; # potrebuji zde lokalne v teto fci zajistit cteni ze souboru po radcich, coz neni standardne pod mod_perl
   my $uid;
   # pokud je fce volana z prostredi mod_perl
   if(defined($ENV{MOD_PERL})) {
      # jde o script bezici pod mod_perl
      if(defined($ENV{SCRIPT_FILENAME})) {
         my @stat=stat($ENV{SCRIPT_FILENAME});
         $uid=$stat[4];
      }
      # jde o volani z mod_perl ale nejde o script - treba navazovani spojeni s DB
      # pri spousteni apache za ucelem autentifikace
      else {
         $uid=0;
      }
   }
   # pokud jde o klasicky CGI script
   else {
      $uid=geteuid;
   }
   my $mycnf;
   if(!$ENV{MOD_PERL}) { # drive zde bylo: "if($uid!=0) {"
      my @passwd=getpwuid $uid;
      $mycnf="$passwd[7]/.my.cnf";
   }
   else {
      $mycnf="/home/mara/.my.cnf.apache";
   }
   open(FILE,$mycnf) || die "nenalezen soubor $mycnf";
   my ($user,$password,$host);
   while(my $radek=<FILE>) {
      chomp($radek);
      if($radek=~/^[\t ]*user[\t ]*=[\t ]*([^\t ]*)$/) {
         $user=$1;
      }
      elsif($radek=~/^[\t ]*password[\t ]*=[\t ]*([^\t ]*)$/) {
         $password=$1;
      }
      elsif($radek=~/^[\t ]*host[\t ]*=[\t ]*([^\t ]*)$/) {
         $host=$1;
      }
   }
   close(FILE);
   if(!length($host)) {
      #$host="localhost";
      $host="sql"; # !!! zrusenim napojenim na localhost, si vynucuji spojeni s mysql pres tcp (jinak to slo pre unix socket) - asi to bude kapku pomalejsi, ale zase ma vahu parametr portu mysql na ktery se napojuji (u localhost a tedy pres unix socket to nemelo vahu)
   }
   my $port;
   if($pkg->web eq "/web-mis") {
      $port="6606";
   }
   elsif($pkg->web eq "/web-mycompany") {
      $port="3306";
   }
   elsif($pkg->web eq "/web-mycompanydev") {
      $port="6608";
   }
   elsif($pkg->web eq "/web-maccess") {
      $port="6609";
   }
   else {
      $port="3306";
   }
   return ($user,$password,$host,$port);
}

#- funkce zajisti spojeni s databazi, pokud spojeni neexistuje
my $dbhscript;
sub dbh {
   if(!defined($dbhscript)) {
      my ($user,$pass,$hostname,$port)=$pkg->sql_user_password;
      my $driver="mysql";
      my $database="test";
      $dbhscript=DBI->connect("DBI:$driver:$database:$hostname:$port",$user,$pass);
   }
   return $dbhscript;
}

#- funkce zajisti spojeni s databazi, kde jsou ulozeny prava
my $dbhpravo;
sub dbhpravo {
   if(!defined($dbhpravo)) {
      my ($user,$pass,$hostname)=$pkg->sql_user_password;
      my $port="3306";
      my $driver="mysql";
      my $database="test";
      $dbhpravo=DBI->connect("DBI:$driver:$database:$hostname:$port",$user,$pass);
   }
   return $dbhpravo;
}

# funkce zajisti odpojeni s databazi po skonceni scriptu
END {
   if(defined($dbhscript)) {
      $dbhscript->disconnect;
   }
   if(defined($dbhpravo)) {
      $dbhpravo->disconnect;
   }
}

#- funkce, ktera prevadi nektere spec. znaky na jejich opis (entities)
sub encode_entities {
   my ($str)=@_;
   my %char2entity = (
      '&' => '&#38;',
      '<' => '&#60;',
      '>' => '&#62;',
      '"' => '&#34;',
      '|' => '&#124;'
   );
   $str=~s/([\<\&\>\"])/$char2entity{$1}/g;
   return $str;
}
#- inverzni fce k encode_entities
sub decode_entities {
   my ($str)=@_;
   use HTML::Entities ();
   $str=HTML::Entities::decode($str);
   return $str;
}

#- funkce, ktera prevadi vsechny znaky mimo pismen anglicke abecedy, cisel a znaku / . : _ na URI opis - vhodne pri generaci URI adresy
# nutne pro hodnoty URI atributu: href, src, action a take: background, classid, codebase, cite, data, datasrc, for (ve znacce <script>), longdesc, profile, usemap
# na prislusne atributy je pak nutne jeste aplikovat encode_entities, za predpokladu, ze obsahuji znak &, ktery nebyl umislne uri encodovan ...
sub encode_uri {
   my ($str)=@_;
   use URI::Escape;
# vypoznamkovany zapis nize fungoval drive (a snad i byl vyzadovan) - u puvodni knihovny
#   $str=uri_escape($str,'^A-Za-z0-9\/\.\:\_'); # zde musi byt apostrofy
   $str=uri_escape($str,'^A-Za-z0-9/.:_'); # zde musi byt apostrofy
   return $str;
}
#- inverzni fce k encode_uri
sub decode_uri {
   my ($str)=@_;
   use URI::Escape;
   $str=uri_unescape($str);
   return $str;
}

#- funkce zjistuje zda ma uzivatel na zadany okruh pravo
sub pravo {
   my ($pkg_p,$user,$okruh,$pravo,$bezblokace)=@_; ## 2002-11-14, pridal jsi parametr $bezblokace - pokud je 1, tak se neohlizim na to zda je okruh zablokovan (vyuzito pri pridelovani prav - at je mozne pridelovat prava i na zablokovane okruhy)
   # nevim proc - ale tenhle radek musi byt pred nasledujici podminkou na user root - jinak to dela problemy - hmmm???
   my $dbh=$pkg->dbhpravo;
   # uzivatel root ma vzdycky na vsecko pravo!
   if($user eq "root") {
      return 1;
   }
   # pokud neni receno zjistuji existenci prava X
   if(!defined($pravo) or $pravo!~/^[XGC]$/) {
      $pravo="X";
   }
   # priprava dotazu
   my $sth_prava=$dbh->prepare(qq{
      select
         Prava.$pravo
      from
         Prava.Prava
      where
         Prava.uziv=? and
         Prava.web=? and
         Prava.okruh=?
   });
   my $sth_pomokruh=$dbh->prepare(q{
      select
         Okruhy.dedicnost,
         Okruhy.blokace
      from
         Prava.Okruhy
      where
         Okruhy.web=? and
         Okruhy.okruh=?
   });
   # zjisteni zda neni system blokovan (pripad, kdy je zablokovan primo okruh "/")
   $sth_pomokruh->execute($pkg->web,"/");
   my $ref_pomokruh=$sth_pomokruh->fetchrow_hashref;
   $sth_pomokruh->finish;
   if($$ref_pomokruh{blokace} eq "1" and !$bezblokace) {
      return 0; # system je z nejakeho duvodu zablokovan - pravo neni
   }
   # prava jsou zjistovana napred u uzivatele a pokud tam neni nic receno, zjistuji se prava na uzivatele "*"
   my @user_list;
   if($user eq "*") {
      @user_list=("*");
   }
   else {
      @user_list=($user,"*");
   }
   my @nadokruhy;
   ## ZMENA 2003-02-10 - pravo se nikdy nededi na podokruhy "#" (dedicnost je mozna jedine, kdyz nadokruh konci znakem "/")
   my $nadokruh=$pkg->nadokruh($okruh);
   if($pravo eq "X" and $okruh!~/\/$/ and $nadokruh=~/\/$/) {
      @nadokruhy=($nadokruh, $okruh); # jen kvuli mozne dedicnosti prava X z rodice
   }
   else {
      @nadokruhy=($okruh);
   }
   foreach my $pomokruh (@nadokruhy) {
      # zjisteni zda neni pomokruh zablokovan a zda se prava dedi na nejblizsi syny (jen na soubory - ne adresare)
      $sth_pomokruh->execute($pkg->web,$pomokruh);
      my $ref_pomokruh=$sth_pomokruh->fetchrow_hashref;
      $sth_pomokruh->finish;
      ## ZMENA 2003-02-07 - pokud neni pomokruh zaveden (nenasel jsem zaznam) a jeho jmeno zacina "/dok/" a jde o dotaz na pravo "X", tak se jedna o dokumentacni cast intranetu v ktere preddefinovane pravo je => pravo je
      ## ZMENA 2003-06-27 - nyni se i k okruhu zacinajiciho znaky "/share/" chovam jako k "/dok/"; pripadne scripty v share, MUSI si samostatne resit pripadna prava (napriklad uzitim fce prava s dotazem na okruh mimo okruhy v /share/)
      if(!defined($ref_pomokruh) and ($pomokruh=~/^\/share\// or $pomokruh=~/^\/dok\// or $pomokruh=~/^\/\~/) and $pravo eq "X") {
         last;
      }
      # pokud neni pomokruh zaveden (nenasel jsem zaznam) nebo je pomokruh zablokovan => pravo neni
      elsif(!defined($ref_pomokruh) or ($$ref_pomokruh{blokace} eq "1" and !$bezblokace)) {
         return 0;
      }
      # zjisteni prava na pomokruh
      foreach my $user (@user_list) {
         $sth_prava->execute($user,$pkg->web,$pomokruh);
         my $ref_prava=$sth_prava->fetchrow_hashref;
         $sth_prava->finish;
         # (pokud jsem nic nenalezl a user je jiz "*") nebo pravo je 0 => pravo neni
         if((!defined($ref_prava) and $user eq "*") or $$ref_prava{$pravo} eq "0") {
            return 0;
         }
         elsif($$ref_prava{$pravo} eq "1") {
            last;
         }
      }
      # pokud se pravo X dedi na nejblizsi syny (pro soubory ne adresare) a $okruh je jiz nejblizsim synem => pravo je
      if($$ref_pomokruh{dedicnost} eq "1" and $pravo eq "X" and $okruh!~/\/$/ and $pomokruh eq $nadokruhy[$#nadokruhy-1]) {
         last;
      }
   }
   return 1;
}

#- vraci v hashi informace o zadanem pravu - kdo ho naposledy menil, ...
sub pravo_info {
   my ($pkg_p,$user,$okruh)=@_;
   my $dbh=$pkg->dbhpravo;
   if(!defined($okruh)) {
      $okruh=$pkg->okruh;
   }
   my $sth_prava=$dbh->prepare(qq{
      select
         Prava.*
      from
         Prava.Prava
      where
         Prava.uziv=? and
         Prava.web=? and
         Prava.okruh=?
   });
   $sth_prava->execute($user,$pkg->web,$okruh);
   my $ref_prava=$sth_prava->fetchrow_hashref;
   $sth_prava->finish;
   $$ref_prava{_exist}=$sth_prava->rows;
   return $ref_prava;
}

#- vraci jmeno serveru - jen jeho jmeno, bez domeny
sub local_hostname {
   open(HOSTNAME,"/etc/hostname") || die "nenalezen soubor /etc/hostname";
   my $hostname=<HOSTNAME>;
   close(HOSTNAME);
   chomp($hostname);
   return $hostname;
}

#- vraci jmeno stanice
sub remote_host {
   return $ENV{REMOTE_HOST};
}

#- vraci prihlaseneho uzivatele
sub remote_user {
   return $ENV{REMOTE_USER};
}

#- vraci domaci stredisko prihlaseneho uzivatele
sub remote_user_str {
   my ($pkg_p,$uziv)=@_;
   if(!defined($uziv)) {
      $uziv=$pkg->remote_user;
   }
   my $dbh=$pkg->dbh;
   my $sth_strhome=$dbh->prepare(q{
      select
         Zamestnanci_zamestnani.str
      from
         Zamestnanci.Uzivatele
         inner join Zamestnanci.Zamestnanci_zamestnani on (Uzivatele.oc=Zamestnanci_zamestnani.oc)
      where
         Uzivatele.uziv=? and
         Zamestnanci_zamestnani.platod<=? and
         Zamestnanci_zamestnani.platdo>=?
   });
   $sth_strhome->execute($uziv,get_env("datum"),get_env("datum"));
   my $ref_strhome=$sth_strhome->fetchrow_hashref;
   $sth_strhome->finish;
   return $$ref_strhome{str};
}

#- vraci 1 pokud neni uzivatel zablokovan jinak vrati 0
sub je_neblokuziv {
   my ($pkg_p,$uziv)=@_;
   my $je_neblokuziv=0;
   if(!defined($uziv)) {
      $uziv=$pkg->remote_user;
   }
   my $dbh=$pkg->dbhpravo;
   my $sth_strhome=$dbh->prepare(q{
      select
         Uzivatele.heslo
      from
         Prava.Uzivatele
      where
         Uzivatele.web=? and
         Uzivatele.uziv=?
   });
   $sth_strhome->execute($pkg->web,$uziv);
   my $ref_strhome=$sth_strhome->fetchrow_hashref;
   $sth_strhome->finish;
   if(
      $sth_strhome->rows and
      $$ref_strhome{heslo}!~/^!/
   ) {
      $je_neblokuziv=1;
   }
   return $je_neblokuziv;
}

#- vraci organizaci pod kterou funkce bezi
sub org {
   my ($pkg_p,$okruh)=@_;
   if(!defined($okruh)) {
      $okruh=$pkg->okruh;
   }
   $okruh=~/\.(\d)\.[^\.]+$/;
   my $org=$1;
   if($org!~/^\d$/) {
      $org="0";
   }
   return $org;
}

#- vraci hash stredisek na ktere ma surfar v momentalnim okruhu pravo
# vyhodne vyuzit pro ziskani hashe stredisek na ktere ma pravo a pak se jiz jen ptam ve stylu if($$str_h{xxxx})
sub str {
   my ($pkg_p,$okruh,$uziv)=@_;
   if(!defined($okruh)) {
      $okruh=$pkg->okruh;
   }
   if(!defined($uziv)) {
      $uziv=$pkg->remote_user;
   }
   my $orglike;
   if($pkg->org($okruh) ne "0") {
      $orglike=$pkg->org($okruh) . "*";
   }
   else {
      $orglike="*";
   }
   my %str_h;
   my $dbh=$pkg->dbhpravo;
   my $sth_str=$dbh->prepare(q{
      select
         Str.str
      from
         Spolecnost.Str
      where
         Str.str like ? and
         Str.str like ? and
         Str.platod<=? and
         Str.platdo>=?
   });
   my @likestr;
   if($okruh=~/#S(.*)$/) {
      @likestr=($1);
   }
   else {
      my $sth=$dbh->prepare(q{
         select
            substring(Prava.okruh,?) as likestr
         from
            Prava.Prava
         where
            Prava.uziv=? and
            Prava.web=? and
            Prava.okruh like ? and
            Prava.X=?
      });
      my $lenokruh=length($okruh);
      $sth->execute($lenokruh+3, $uziv, $pkg->web, $okruh . "#S" . "%", "1" );
      while(my $ref=$sth->fetchrow_hashref) {
         push(@likestr,$$ref{likestr});
      }
      $sth->finish;
   }
   foreach my $likestr (@likestr) {
      if($likestr=~/^(d+)\*?$/) {
         my $len=length($1);
         my $uzivstr=$pkg->remote_user_str($uziv);
         if($len eq length($uzivstr)) {
            $str_h{$uzivstr}=1;
         }
         else {
            $likestr= substr($uzivstr,0,$len) . "*";
         }
      }
      elsif($likestr!~/\*/) {
         $str_h{$likestr}=1;
      }
      if($likestr!~/^d/ and $likestr=~/\*/) {
         $likestr=~s/\*/\%/g;
         $orglike=~s/\*/\%/g;
         $sth_str->execute($orglike,$likestr,get_env("datum"),get_env("datum")); # ZMENA 18.12.2001 zamena $pkg->date_now za get_env("datum")
         while(my $ref_str=$sth_str->fetchrow_hashref) {
            $str_h{$$ref_str{str}}=1;
         }
         $sth_str->finish;
      }
   }
   return \%str_h;
}

#- vraci aktualni okruh
sub okruh {
   my $okruh=$ENV{SCRIPT_URL};
   # u pocitace adm, natvrdo dodavam pred jmeno okruhu retezec "/dok"
   if($pkg->local_hostname eq "adm") {
      $okruh="/dok".$okruh;
   }
   return $okruh;
}

#- zablokuje/odblokuje aktualni okruh
sub okruh_blokace {
   my ($pkg_p,$blokace)=@_;
   my $okruh=$pkg->okruh;
   my $dbh=$pkg->dbhpravo;
   my $sth=$dbh->prepare(q{
      update
         Prava.Okruhy
      set
         Okruhy.blokace=?
      where
         Okruhy.web=? and
         Okruhy.okruh=?
   });
   $sth->execute($blokace,$pkg->web,$okruh);
}

#- vraci v hashi informace o zadanem okruhu
sub okruh_info {
   my ($pkg_p,$okruh)=@_;
   my $dbh=$pkg->dbhpravo;
   if(!defined($okruh)) {
      $okruh=$pkg->okruh;
   }
   my $sth_okruhy=$dbh->prepare(q{
      select
         Okruhy.*
      from
         Prava.Okruhy
      where
         Okruhy.web=? and
         Okruhy.okruh=?
   });
   $sth_okruhy->execute($pkg->web,$okruh);
   my $ref_okruhy=$sth_okruhy->fetchrow_hashref;
   $sth_okruhy->finish;
   $$ref_okruhy{_exist}=$sth_okruhy->rows;
   return $ref_okruhy;
}

#- vraci nazev aktualniho okruhu (respektive zadaneho)
sub okruh_nazev {
   my ($pkg_p,$okruh)=@_;
   my $info_okruh=$pkg->okruh_info($okruh);
   return $$info_okruh{nazev};
}

#- varci nadokruh k zadanemu okruhu
sub nadokruh {
   my ($pkg_p,$okruh)=@_;
   my $nadokruh=$okruh;
   if($okruh=~/\/$/) {
      chop($nadokruh);
   }
   my $lomeno=rindex($nadokruh,"/");
   my $ferda=rindex($nadokruh,"#");
   if($ferda>$lomeno) {
      $nadokruh=substr($nadokruh,0,$ferda);
   }
   else {
      $nadokruh=substr($nadokruh,0,$lomeno+1);
   }
   if(!length($nadokruh)) {
      $nadokruh=undef;
   }
   return $nadokruh;
}

#- varci nadokruhy k zadanemu okruhu
sub nadokruhy {
   my ($pkg_p,$okruh)=@_;
   my @nadokruhy;
   $okruh=$pkg->nadokruh($okruh);
   while(defined($okruh)) {
      push(@nadokruhy,$okruh);
      $okruh=$pkg->nadokruh($okruh);
   }
   return reverse(@nadokruhy);
}

#- vraci aktualni datum a cas ve tvaru pro zapis do databaze
sub datetime_now {
   return date(time)->strftime("%Y-%m-%d %X");
}

#- vraci aktualni datum
sub date_now {
   return date(time)->strftime("%Y-%m-%d");
}

#- vraci datum, ktere je povazovano za pritomnost - uzivano v aktualizacnich fci, pro urceni jeke zaznamy z jakym datem platnosti je mozne menit (minulost menit nelze, u pritomnosti je mozne jen zmenit platnost do minulosti dane timto datem, budoucnost je mozne menit libovolne)
sub date_present {
   my $date_present;
   if($pkg->pravo($pkg->remote_user,"/Prava/Specialni/specmenithistorii","X")) {
      $date_present="1900-01-01";
   }
   else {
      $date_present=$pkg->date_adddecade(date(time)->strftime("%Y-%m-%d"),-1);
   }
   return $date_present;
#   return date(time-86400)->strftime("%Y-%m-%d");
#   return $pkg->date_now;
}

#- vraci na zaklade dat platod a platdo, zda jde o minulost (-1), pritomnost (0) ci budoucnost (1)
sub epoch {
   my ($pkg_p, $platod,$platdo,$akt)=@_;
   my $status;
   my $date_present;
   if($akt) { # u aktualizacnich fci pracuji s fci date_present
      $date_present=$pkg->date_present;
   }
   else { # u zobrazovacich fci je dulezite aktualni datum
      $date_present=get_env("datum");
   }
   # minulost
   if($platdo lt $date_present) {
      $status=-1;
   }
   # pritomnost
   elsif($platod le $date_present and $platdo ge $date_present) {
      $status=0;
   }
   # budoucnost
   else {
      $status=1;
   }
   return $status;
}

#- vraci datum, pro ktere od ktereho je zobrazovana historie - starsi zaznamy v zobrazovacich funkcich i s historii zobrazovat nebudu
sub historie {
   my $year=substr(get_env("datum"),0,4);
   $year-=5;
   return $year . "-01-01";
}

#- vraci aktualni obdobi
sub period_now {
   return date(time)->strftime("%Y-%m");
}

#- vraci aktualni datum a cas ve tvaru pro zapis do databaze
sub year_now {
   ## Mozna pro praci s minulosti bych mohl ve zvlastnich pripadech tento udaj brat z cookies
   return date(time)->strftime("%Y");
}

#- pricte k zadanemu obdobi zadany pocet mesicu
# Priklady: My->period_addmonth("2001-01",-1) ->    2000-12
#           My->period_addmonth("2001-12-21",1) ->  2002-01
sub period_addmonth {
   my ($pkg_p,$period,$addmonth)=@_;
   my ($year,$month)=split(/-/,$period);
   my $month_pom=(12*$year+$month)+$addmonth-1;
   $year=int($month_pom/12);
   $month=sprintf("%2.2d",$month_pom-($year*12)+1);
   return $year . "-" . $month;
}

#- vraci index zadane periody
# co jsou indexy?
# 0: aktualni obdobi; 1: akt.obdobi+1mesic; ... ($indexmax-1): do konce roku; $indexmax: do konce veku
sub period_index {
   my ($pkg_p, $dateval,$type,$startingdate,$indexmax)=@_;
   my $index;
   if($type eq "w") {
      my $period=$pkg->date_to_fwdate($dateval);
      my $period_now=$pkg->date_to_fwdate($startingdate);
      foreach my $i (0..($indexmax-2)) {
         my $dateD=date($period_now); $dateD+=(7*$i)."D";
         if($period le $dateD->strftime("%Y-%m-%d")) {
            $index=$i;
            last;
         }
      }
      if(!defined($index)) {
         # zjisteni posledni periody v roce
         my $dateD=date($period_now); $dateD+=(7*($indexmax-1))."D";
         my $year=$dateD->strftime("%Y");
         my $dateD=date($year."-12-31");
         my $periodyear=$pkg->date_to_fwdate($dateD->strftime("%Y-%m-%d"));
         if($period le $periodyear) {
            $index=$indexmax-1;
         }
         else {
            $index=$indexmax;
         }
      }
   }
   if($type eq "d") {
      my $period=$pkg->date_to_decade($dateval);
      my $period_now=$pkg->date_to_decade($startingdate);
      foreach my $i (0..($indexmax-2)) {
         if($period<=($period_now+$i)) {
            $index=$i;
            last;
         }
      }
      if(!defined($index)) {
         # zjisteni posledni periody v roce
         my $year=substr($pkg->decade_to_date($period_now+$indexmax-1),0,4);
         my $dateD=date($year."-12-31");
         my $periodyear=$pkg->date_to_decade($dateD->strftime("%Y-%m-%d"));
         if($period<=$periodyear) {
            $index=$indexmax-1;
         }
         else {
            $index=$indexmax;
         }
      }
   }
   elsif($type eq "m") {
      my $period=substr($dateval,0,7);
      my $period_now=substr($startingdate,0,7);
      foreach my $i (0..($indexmax-2)) {
         if($period le $pkg->period_addmonth($period_now,$i)) {
            $index=$i;
            last;
         }
      }
      if(!defined($index)) {
        # zjisteni posledni periody v roce
        my $year=substr($pkg->period_addmonth($period_now,$indexmax-1),0,4);
        my $periodyear=$year."-12";
        if($period le $periodyear) {
           $index=$indexmax-1;
        }
        else {
           $index=$indexmax;
        }
      }
   }
   elsif($type eq "q") {
      my $period=$pkg->date_to_quarter($dateval);
      my $period_now=$pkg->date_to_quarter($startingdate);
      foreach my $i (0..($indexmax-2)) {
         if($period<=$period_now+$i) {
            $index=$i;
            last;
         }
      }
      if(!defined($index)) {
        # zjisteni posledniho kvartalu v roce
        my $quarter=$period_now+($indexmax-1);
        my $y=int(($quarter-1)/4);
        $quarter=4*$y+4;
        if($period<=$quarter) {
           $index=$indexmax-1;
        }
        else {
           $index=$indexmax;
        }
      }
   }
   return $index;
}

#- vraci popisku pro prislusny index
sub period_index_legend {
   my ($pkg_p, $index,$type,$startingdate,$indexmax)=@_;
   my $legend;
   if($type eq "w") {
      my $period_now=$pkg->date_to_fwdate($startingdate);
      if($index<=($indexmax-2)) {
         my $dateD=date($period_now); $dateD+=(7*$index)."D";
         $legend=$dateD->strftime("%y%m%d");
      }
      elsif($index==($indexmax-1)) {
         my $dateD=date($period_now); $dateD+=(7*($indexmax-1))."D";
         my $year=$dateD->strftime("%Y");
         my $dateD=date($year."-12-31");
         $legend=$pkg->date_to_fwdate($dateD->strftime("%Y-%m-%d"));
         $legend=~s/-//g; $legend="-".substr($legend,2);
      }
      else {
         $legend="-991231";
      }
   }
   elsif($type eq "d") {
      my $period_now=$pkg->date_to_decade($startingdate);
      if($index<=($indexmax-2)) {
         my $datum_pom=$pkg->decade_to_date($period_now+$index);
         $legend= substr($datum_pom,2,2) . substr($datum_pom,5,2) . substr($datum_pom,8,2);
      }
      elsif($index==($indexmax-1)) {
         my $datum_pom=$pkg->decade_to_date($period_now+$index);
         $legend="-" . substr($datum_pom,2,2) . "1221";
      }
      else {
         $legend="-991221";
      }
   }
   elsif($type eq "m") {
      my $period_now=substr($startingdate,0,7);
      if($index<=($indexmax-2)) {
         $legend= substr($pkg->period_addmonth($period_now,$index),2,2) . substr($pkg->period_addmonth($period_now,$index),5,2);
      }
      elsif($index==($indexmax-1)) {
         $legend="-" . substr($pkg->period_addmonth($period_now,($indexmax-1)),2,2) . "12";
      }
      else {
         $legend="-9912";
      }
   }
   elsif($type eq "q") {
      my $period_now=$pkg->date_to_quarter($startingdate);
      if($index<=($indexmax-2)) {
         my $quarter=$period_now+$index;
         my $y=int(($quarter-1)/4);
         $quarter-=4*$y;
         $legend= substr("${y}${quarter}Q",2);
      }
      elsif($index==($indexmax-1)) {
         my $quarter=$period_now+($indexmax-1);
         my $y=int(($quarter-1)/4);
         $quarter=4*$y+4;
         $y=int(($quarter-1)/4);
         $quarter-=4*$y;
         $legend="-" . substr("${y}${quarter}Q",2);
      }
      else {
         $legend="-994Q";
      }
   }
   return $legend;
}

#- vraci datum prvniho dne v tydnu na zadane datum
sub date_to_fwdate {
   my ($pkg_p, $dateval)=@_;
   my $date=date($dateval);
   my $wday=$date->_wday;
   if($wday==0) {
      $wday=6;
   }
   else {
      $wday-=1;
   }
   $date-=$wday."D";
   return $date->strftime("%Y-%m-%d");
}

#- prevadi datum na pocet kvartalu
sub date_to_quarter {
   my ($pkg_p, $date)=@_;
   my ($y,$m)=split(/-/,$date);
   my $mm;
   if($m<4) {
      $mm=1;
   }
   elsif($m<7) {
      $mm=2;
   }
   elsif($m<10) {
      $mm=3;
   }
   else {
      $mm=4;
   }
   return ((4*$y)+$mm);
}

#- prevadi datum na pocet dekad
sub date_to_decade {
   my ($pkg_p,$date)=@_;
   my ($y,$m,$d)=split(/-/,$date);
   my $dd;
   if($d<11) {
      $dd=1;
   }
   elsif($d<21) {
      $dd=2;
   }
   else {
      $dd=3;
   }
   return ((36*$y)+(3*$m)+$dd);
}

#- prevadi pocet dekad na datum
sub decade_to_date {
   my ($pkg_p,$decade)=@_;
   my $y=int(($decade-4)/36); # odecitam 4 schvalne... (12-3dek -> 39; 39-4=35 - neni delitelne 36)
   $decade-=36*$y;
   my $m=int(($decade-1)/3); # odecitam 1 schvalne... (3dek -> 3; 3-1=2 - neni delitelne 3)
   $decade-=3*$m;
   my $d=$decade*10-9;
   return $y . "-" . sprintf("%2.2d",$m) . "-" . sprintf("%2.2d",$d);
}

#- pricte k datumu urcity pocet dekad
sub date_adddecade {
   my ($pkg_p,$date,$adddecade)=@_;
   my $decade=$pkg->date_to_decade($date)+$adddecade;
   return ($pkg->decade_to_date($decade));
}

#- pricte k datumu urcity pocet dni
sub date_addday {
   my ($pkg_p, $date,$addday)=@_;
   my $datep=date($date)+($addday.'D');
   return $datep->strftime("%Y-%m-%d");
}

#- vrati rozdil ve dnech mezi dvema daty
sub date_subtract {
   my ($pkg_p, $date1,$date2)=@_;
   my $reldate=date($date1)-date($date2);
   return $reldate->day;
}

#- vraci datum, od ktereho maji pri automatickych zapisech platit nektere udaje
# z duvodu kompatibility z hpux, nevraci aktualni datum,
# ale datum zacatku aktualni dekady
sub date_autoplatod {
   return $pkg->date_adddecade(get_env("datum"),0);
}

#- kontrola datum - pokud je datum platne tak ho vrati, jinak vrati undef
sub check_datum {
   my ($pkg_p,$field_val)=@_;
   my ($year,$month,$day)=split(/-/,$field_val);
   require Date::Calc;
   if(!Date::Calc::check_date($year,$month,$day) or $field_val!~/^(\d){4}-(\d){2}-(\d){2}$/) { # dulezita je i tvarova kontrola jelikoz obcas srovnavas datumy velikostne jako retezce a potrebujes tam mit nuly (treba 2000-01-01)
      $field_val=undef;
   }
   return $field_val;
}

# vraci prunik retezcu (odzacatku)
sub str_intersection {
   my ($pkg_p,$str1,$str2)=@_;
   my $str="";
   for(my $i=0; $i<length($str1); ++$i) {
      if(substr($str1,$i,1) eq substr($str2,$i,1)) {
         $str.=substr($str1,$i,1);
      }
      else {
         last;
      }
   }
   return $str;
}

#- title
sub title_basic {
   my ($pkg_p,$okruh)=@_;
   if(!defined($okruh)) {
      $okruh=$pkg->okruh;
   }
   my $title= $pkg->okruh_nazev($okruh) . " " . get_env("title") . " (" . $pkg->remote_user . " " . $pkg->datetime_now . ")";
   return $title;
}

#- nastaveni/nacteni uzivatelskeho cookie
sub cookie {
   my ($key,$val)=@_;
   my $dbh=$pkg->dbhpravo;
   if(defined($val)) {
      my $sth=$dbh->prepare(q{
         replace
            Prava.Cookie
            (Cookie.uziv,Cookie.cookie,Cookie.hodnota)
         values
            (?,?,?)
      });
      $sth->execute($pkg->remote_user,"$key","$val");
   }
   else {
      my $sth=$dbh->prepare(q{
         select
            Cookie.hodnota
         from
            Prava.Cookie
         where
            Cookie.uziv=? and
            Cookie.cookie=?
      });
      $sth->execute($pkg->remote_user,"$key");
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $val=$$ref{hodnota};
   }
   return $val;
}

#- vraci definici
sub outputdev {
   my ($pkg_p, $query)=@_;
   my $outputdev;
   my $dbh=$pkg->dbhpravo;
   my $sth;
   my $ref;
   if(defined($query) and defined($query->param('_uziv')) and defined($query->param('_nazev'))) {
      $sth=$dbh->prepare(q{
         select
            Vystupzarizeni.*
         from
            Prava.Vystupzarizeni
         where
            Vystupzarizeni.web=? and
            Vystupzarizeni.uziv=? and
            Vystupzarizeni.nazev=?
      });
      $sth->execute($pkg->web,$query->param('_uziv'),$query->param('_nazev'));
      $ref=$sth->fetchrow_hashref;
      $sth->finish;
   }
   elsif(defined($query) and $query->param('_tisk') eq "1") {
      $sth=$dbh->prepare(q{
         select
            if(Vystupzarizeni.uziv=?,1,if(Vystupzarizeni.ipzap=?,2,3)) as radit,
            Vystupzarizeni.*
         from
            Prava.Vystupzarizeni
         where
            Vystupzarizeni.web=? and
            (Vystupzarizeni.uziv in(?,"*") or Vystupzarizeni.ipzap=?) and
            Vystupzarizeni.hlavni=1 and
            Vystupzarizeni.typzar like "printer%"
         order by
            radit asc,
            Vystupzarizeni.typzar asc
         limit
            1
      });
      $sth->execute($pkg->remote_user,$pkg->remote_host,$pkg->web,$pkg->remote_user,$pkg->remote_host);
      $ref=$sth->fetchrow_hashref;
      $sth->finish;
   }
   else {
      $sth=$dbh->prepare(q{
         select
            Vystupzarizeni.*
         from
            Prava.Vystupzarizeni
         where
            Vystupzarizeni.web=? and
            Vystupzarizeni.uziv=? and
            Vystupzarizeni.hlavni=? and
            Vystupzarizeni.typzar=?
      });
      $sth->execute($pkg->web,$pkg->remote_user,"1","browser");
      $ref=$sth->fetchrow_hashref;
      $sth->finish;
   }
   if($sth->rows) {
      $outputdev=$ref;
   }
   else {
      $sth=$dbh->prepare(q{
         select
            Vystupzarizeni.*
         from
            Prava.Vystupzarizeni
         where
            Vystupzarizeni.web=? and
            Vystupzarizeni.uziv=? and
            Vystupzarizeni.nazev=?
      });
      if($ENV{HTTP_USER_AGENT}=~/^Mozilla/) {
         $sth->execute($pkg->web,"*","MSIE");
         my $ref=$sth->fetchrow_hashref;
         $sth->finish;
         $outputdev=$ref;
      }
      else {
         $sth->execute($pkg->web,"*","links");
         my $ref=$sth->fetchrow_hashref;
         $sth->finish;
         $outputdev=$ref;
         # novy links nyni hlasi rozmery terminalu a tak toho vyuzivam a prevalcovavam prednastaveny pocet radku a sloupcu...
         if($ENV{HTTP_USER_AGENT}=~/(\d+)x(\d+)/) {
            $$outputdev{radku}=$2-2;
            $$outputdev{sloupcu}=$1-2;
         }
      }
   }
   # pripadne doplneni promene $$outputdev{typzarspec}
   if(!length($$outputdev{typzarspec})) {
      if($$outputdev{typzar} eq "browser") {
         $$outputdev{typzarspec}="text/html";
      }
      elsif($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") {
         $$outputdev{typzarspec}= 'lp@' . $pkg->remote_host;
      }
      elsif($$outputdev{typzar} eq "mail") {
         $$outputdev{typzarspec}= $pkg->remote_user . '@' . $pkg->domain;
      }
   }
   # pripadna definice $$outputdev{idcs}
   if(defined($query)) {
      $$outputdev{idcs}=$query->param("idcs");
   }
   return $outputdev;
}

#- funkce ktera umoznuje presmerovat na zadanou stranku
sub redirect {
   my ($pkg_p,$location)=@_;
   print "HTTP/1.1 302 Found\n";
   print "Location: $location\n";
   print "Content-Type: text/html\n\n";
   print '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">';
   print '<HTML><HEAD>';
   print '<TITLE>Presmerovani</TITLE>';
   print '</HEAD><BODY>';
   print 'Dokument je <A HREF="' .$location. '">zde</A>.<P>';
   print '</BODY></HTML>';
   exit;
}

#- funkce preklada dle slovniku z klice (cestiny) na definovany jazyk
sub trl {
   my ($klic,@values)=@_;
   my $dbh=$pkg->dbhpravo;
   my $translation;
   my $sth=$dbh->prepare(q{
      select
         Lokalizace.*
      from
         Prava.Lokalizace
      where
         Lokalizace.klic=? and
         Lokalizace.jazyk=?
   });
   $sth->execute($klic,get_env("lang"));
   if($sth->rows) {
      my $ref=$sth->fetchrow_hashref;
      $translation=$$ref{hodnota};
   }
   else {
      $translation=$klic;
   }
   $sth->finish;
   # doplneni @values do $translation na mista :0, :1, ...
   my $translation_and_values;
   foreach my $translation_substr (split(/(:\d)/,$translation)) {
      if($translation_substr=~/^:(\d)$/) {
         $translation_and_values.=$values[$1];
      }
      else {
         $translation_and_values.=$translation_substr;
      }
   }
   return $translation_and_values;
}

return 1;

