package MyXML;

# !!! Poznamka v teto knihovne dedis vse z XML::LibXML::Element a navic pridavas dalsi veci, zejmena "aT"

my $pkg="MyXML";

use Exporter ();
@ISA=qw( Exporter XML::LibXML::Element );

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use XML::LibXML;


#- zajisteni dedicnosti objektu z XML::LibXML::Element
sub new {
   my $type = shift;
   my $self = XML::LibXML::Element->new(@_);
   bless $self, $type;
}

#- funkce vytvori XHM dokument urceny pro HTML vystup
# uziti my ($docO,$htmlO,$bodyO,$lineno)=MyXML->creahtml;
sub creahtml {
   my ($pkg_p, $outputdev,$idcs)=@_;
   # tvorba zakladnich html znacek
   my $docO=XML::LibXML::Document->new;
   my $htmlO=$pkg->new('html');
   $docO->setDocumentElement($htmlO);
   my $head=$htmlO->aT("head");
   $head->aT("title",{},My->title_basic);
   my $filenamecss="/share/templates/my.css";
   if($$outputdev{typzar} eq "browser") {
      $head->aT("script",{type=>"text/javascript",src=>encode_uri("/share/scripts/my.js")});
      $head->aT("link",{rel=>"stylesheet",type=>"text/css",href=>encode_uri($filenamecss)});
      if(1) { # specialne, aby fungoval HTML editorek HTMLArea
         $head->aT("script",{type=>"text/javascript",src=>encode_uri("/share/htmlarea/htmlarea.js")});
         $head->aT("script",{type=>"text/javascript",src=>encode_uri("/share/htmlarea/lang/en.js")});
         $head->aT("script",{type=>"text/javascript",src=>encode_uri("/share/htmlarea/dialog.js")});
         $head->aT("link",{rel=>"stylesheet",type=>"text/css",href=>encode_uri("/share/htmlarea/htmlarea.css")});
         #$head->aT("link",{rel=>"shortcut icon",href=>encode_uri("/share/icons/tux.ico")});
      }
   }
   elsif($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") {
      my $hrefbase="http://localhost/";
      $head->aT("base",{href=>$hrefbase});
   }
   else {
      my $hrefbase=My->weburl;
      $head->aT("base",{href=>$hrefbase});
      my $strcss;
      open(CSS,My->www_path.$filenamecss);
      while(my $radek=<CSS>) {
         $strcss.=$radek;
      }
      $strcss=~s/[\@a-zA-Z0-9\-]+[ \t\n]*:{0,1}[ \t\n]*url[^;]+;//g; # vykuchani odkazu z CSS (predevsim na obrazky), ktere by pak nutili v mailu pri zobrazeni stranky k autorizaci, jeloko obrazky nebudou soucasti mailu
      close(CSS);
      $head->aT("style",{type=>"text/css"},$strcss);
   }
   my $bodyO=$htmlO->aT("body");
   my $bodyOO;
   my $h1text;
   if($$outputdev{typzar} eq "browser" or (($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") and $$outputdev{typvystupu} eq "table")) {
      $h1text=My->okruh_nazev;
   }
   else {
      $h1text=My->title_basic;
   }
   if(!$$outputdev{bezpre} and ($$outputdev{typvystupu} eq "txt" or $$outputdev{typvystupu} eq "txtfixed")) {
      $bodyOO=$bodyO->aT("pre");
      $bodyOO->aT("span",{class=>"h1"},$h1text);
      $bodyOO->aT(undef,{},"\n\n");
   }
   else {
      $bodyOO=$bodyO->aT("div");
      if($$outputdev{typzar} eq "browser") {
         $bodyOO->aT("img", { src => "/share/icons/logo.png", alt => "logo", border => "0", align => "right" });
      }
      $bodyOO->aT("h1", {}, $h1text);
   }
   if($$outputdev{plnyformat}) {
      $bodyOO=$bodyO->aT("pre", { plnyformat=>"1" });
   }
   #
   my $okruh=My->okruh;
   # paticka - jen u vystupu do prohlizece
   if($$outputdev{typzar} eq "browser") {
      # navigacni paticka
      my $pO=$bodyO->aT("div", { class => "footer" });
      $pO->aT("hr", { class=>"footer" });
      my $pomokruh="";
      my @nadokruhy=(My->nadokruhy($okruh), ,$okruh);
      if(defined($$outputdev{patickahloubka}) and $$outputdev{patickahloubka}<=$#nadokruhy) {
         @nadokruhy=@nadokruhy[0..($$outputdev{patickahloubka}-1)];
      }
      foreach my $pomokruh (@nadokruhy) {
         my $href=$pomokruh;
         ## ZMENA 2002-08-22 - chci, aby po odklepnuti linku dole najel formular s presnou definici vysledku, ktery jsem mel nejety
         ## ZMENA 2003-01-15 - nechci u aktualizacnich funkci uplatnovala moznost session (asi by to ale chtelo udelat lepe nez dotazem na nazev okruhu...)
         if(defined($idcs) and $pomokruh eq $nadokruhy[-1] and My->okruh_nazev!~/^Akt\./ and !defined($$outputdev{patickahloubka})) {
            $href.="?_idcs=".$idcs."&_nosubmit="."1";
         }
         my $aO=$pO->aT("a",{class=>"footer",target=>"_top",href=>$href});
         $aO->aT(undef,{},My->okruh_nazev($pomokruh));
         if($pomokruh ne $nadokruhy[$#nadokruhy]) {
            $pO->aT(undef,{}," \x{7c} ");
         }
      }
      # moznost zmenit typ vystupu
      my $pO=$bodyO->aT("div", { class => "footer" });
      if(defined($idcs)) {
         $pO->aT("a",{ class=>"footer",href=> "/share/scripts/helpredirect.phtml?" . "okruh=" . encode_uri($okruh) }, "?");
         $pO->aT(undef,{}," \x{7c} ");
         $pO->aT("a",{ class=>"footer",href=> "/Prava/okruh.phtml?" . "okruh=" . encode_uri($okruh) . "&" . "idcs=" . encode_uri($idcs) }, "Okruh");
         $pO->aT(undef,{}," \x{7c} ");
         $pO->aT("a",{ class=>"footer",href=> My->okruh . "?" . "_idcs=" . encode_uri($idcs) . "&" . "_tisk=" . encode_uri("1") }, "Tisk");
      }
   }
   return ($docO,$htmlO,$bodyOO,2);
}

#- funkce vytvori XML dokument a hned tam vlozi znacku table
# uziti: my ($docO,$tableO,$colsO,$rowsO)=MyXML->creatable;
sub creatable {
   my $doc=XML::LibXML::Document->new;
   my $table=$pkg->new('table');
   $doc->setDocumentElement($table);
   my $cols=$table->aT("cols");
   my $rows=$table->aT("rows");
   return ($doc,$table,$cols,$rows);
}

#- funkce vytvori XML dokument a hned tam vlozi znacku xhtml
# uziti: my ($docO,$xhtmlO)=MyXML->creaxhtml;
sub creaxhtml {
   my $doc=XML::LibXML::Document->new;
   my $xhtml=$pkg->new("xhtml");
   $doc->setDocumentElement($xhtml);
   return ($doc,$xhtml);
}

#- funkce pridava tag k jiz nejakemu tagu
# uziti: my $znacka=$cols->aT("znacka",{atribut=>"hodnota"},"text");
sub aT {
   my ($tagp,$tagname,$attr,$textval)=@_;
   $textval=encodeToUTF8("windows-1250",$textval);
   #if($textval eq "NBSP") {
   #   $textval="\x{a0}";
   #}
   my $tag;
   if(defined($tagname)) {
      $tag=$pkg->new($tagname);
      $tagp->appendChild($tag);
   }
   else {
      $tag=$tagp;
   }
   foreach my $attrname (keys %{$attr}) {
      $tag->sA($attrname,$$attr{$attrname});
   }
   if(defined($textval)) {
      my $text=XML::LibXML::Text->new($textval);
      $tag->appendChild($text);
   }
   return $tag;
}

#- funkce nastavuje u jiz existujiciho tagu atribut (narozdil od setAttribute zde dochazi k prekodovani cestiny)
sub sA {
   my ($tagp,$attrname,$attrval)=@_;
   $attrval=encodeToUTF8("windows-1250",$attrval);
   return $tagp->setAttribute($attrname,$attrval);
}

#- funkce pridava detske nody zadaneho nodeI k zadanemeu nodeO
sub aNchilds {
   my ($nodeO,$nodeI)=@_;
   foreach my $nodeIchild ($nodeI->findnodes('*|text()')) {
      $nodeO->appendChild($nodeIchild->cloneNode(1));
   }
}

#- funkce pridava detske nody zadaneho nodeI k zadanemeu nodeO az na nody (znacky) "a"
sub aNchilds_nolink {
   my ($nodeO,$nodeI)=@_;
   foreach my $nodeIchild ($nodeI->findnodes('*|text()')) {
      if($nodeIchild->nodeName eq "a") {
         $nodeO->aT(undef,{},$nodeIchild->findvalue('.'));
      }
      else {
         $nodeO->appendChild($nodeIchild->cloneNode(1));
      }
   }
}

#- funkce pridava detske nody k zadanemeu $nodeO a jako vstup se predpoklada retezec v HTML
sub aNchilds_fromStringHTML {
   my ($nodeO,$htmlstring)=@_;
   my $parser=XML::LibXML->new();
   my $docI=$parser->parse_html_string(
      q{
         <html>
         <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
         <body>
      }.
      $htmlstring.
      q{
         </body>
         </html>
      }
   );
   my ($nodeI)=$docI->findnodes('/html/body');
   my @matching_tags = $nodeI->getElementsByTagName("span");
   foreach my $match (@matching_tags) { 
      my $attrs = $match->attributes;
      foreach my $attr (keys %{$$attrs{NodeMap}}) {
         if($attr eq "style") {
            my $value = $$attrs{NodeMap}{$attr}->value;
            if($value eq 'font-weight: bold;') {
               $match->setNodeName('strong');
               $match->removeAttribute("style");
            }
            elsif($value eq 'font-style: italic;') {
               $match->setNodeName('em');
               $match->removeAttribute("style");
            }
            elsif($value eq 'text-decoration: underline;') {
               $match->setNodeName('u');
               $match->removeAttribute("style");
            }
            elsif($value eq 'text-decoration: line-through;') {
               $match->setNodeName('strike');
               $match->removeAttribute("style");
            }
         }
      }
   }
   $nodeO->aNchilds($nodeI);
}

#- funkce tiskne HTML kod
sub aNchilds_toStringHTML {
   my ($nodeI)=@_;
   my $htmlstring;
   foreach my $nodeIchild ($nodeI->findnodes('*|text()')) {
      $htmlstring.=$nodeIchild->toString;
   }
   # Po opakovanem ukladani textu html editorkem v mozille narustal
   # kod v mistech, kde byly prazdne radky (neustale pribyvalo &#13;)
   # resim to zatim zapisem nize.
   $htmlstring=~s/\&\#13;//g;
   return $htmlstring;
}

return 1;

